.PS
# Hat.m4
threeD_init
copy "HOMELIB_`'dpictools.pic"
scale = 0.5

  azimuth = 25                     # View angles in degrees
  elevation = 20
  setview(azimuth,elevation)
                                   # the 3D object
  define(`hat',`cosd($1)*($2),sind($1)*($2),(($2)^2-1)^2') 

                                   # grid parameters
  dang = 12
  maxy = 1.25
  dy = 0.06
                                   # create the arrays and sort
  n = 0 
  for t = dang/2 to 360.1 by dang do {
    for y=dy/2 to maxy by dy do { n +=1
      t[n] = t
      y[n] = y
      d[n] = dot3D(hat(t,y),View3D) # distance toward the front
      ix[n] = n
      } } 
  dpquicksort(d,1,n,ix)

                                   # draw the panels
thinlines_
  for i = 1 to n do {
    tc = t[ix[i]]; yc = y[ix[i]]
    SE: (project(hat(tc+dang/2,yc-dy/2)))
    SW: (project(hat(tc-dang/2,yc-dy/2)))
    NW: (project(hat(tc-dang/2,yc+dy/2)))
    NE: (project(hat(tc+dang/2,yc+dy/2)))
    line fill abs(yc^2-1) from SE to SW then to NW then to NE then to SE
  }
.PE
